jQuery.plugin("de_epages.paymenttypes.inc.validatesepadata", {
    plugin: [
        "ep.core",
        "ep.ajax",
        "ep.ui.tooltip",
        "de_epages.core"
    ],
    DOM: true
}, function($){

    $.scope("de_epages.paymenttypes.inc").validatesepadata = function (IBANBICWarnMessageNode, SEPAWarnMessageNode, accountNoNode, bankCodeNode, nextButton, buttonText) {
            debugger;
            nextButton.on('click', function (event) {
                var $this = $(this);
                if (!IBANBICWarnMessageNode.is(':visible')) {
                    event.preventDefault();

                    // check the given IBAN and BIC
                    ep.ajax({
                        url: '?',
                        dataType: 'json',
                        type: 'POST',
                        data: {
                            ObjectID: ep.config.objectId,
                            ChangeAction: 'JSONValidateSEPAData',
                            BankAccountNo: accountNoNode.val(),
                            BankCode: bankCodeNode.val(),
                            ViewAction: 'JSONViewResponse'
                        }
                    })
                        // IBAN and BIC are valid >> continue the checkout process
                        .done(function () {
                            $this.trigger('submit');
                        })
                        // some error is thrown
                        .fail(function (jqXHR, statusText, errorThrown) {
                            $.each(errorThrown, function (i, error) {
                                // IBAN and/or BIC are not in the expected format
                                if (error.Reason === "FORMAT_NOT_IBAN" || error.Reason === "FORMAT_NOT_BIC") {
                                    // remove the sepa message to prevent the display of two warnings
                                    if (SEPAWarnMessageNode.length) {
                                        SEPAWarnMessageNode.remove();
                                    }

                                    // show message and change text of the "next" button
                                    IBANBICWarnMessageNode.removeClass('HideElement');
                                    nextButton.html(buttonText);

                                    // highlight IBAN if it is invalid
                                    if (error.Reason === "FORMAT_NOT_IBAN") {
                                        accountNoNode.addClass('ui-warn');
                                    }

                                    // hightlight BIC if it is invalid
                                    if (error.Reason === "FORMAT_NOT_BIC") {
                                        bankCodeNode.addClass('ui-warn');
                                    }
                                // we continue the checkout if there is another problem with the request
                                } else {
                                    $this.trigger('submit');
                                }
                            });
                        });
                }
            });
        };
});
